<template>
    <ul v-if="produtos.length">
        <li v-for="(produto, indice) in produtos" :key="indice">
           <p>{{produto.nome}} </p>
           <p>{{converteValorInteiroMoeda(produto.valor)}} </p>
           <div class="remover-item-carrinho">
                <button class="button is-danger is-small" @click="removeItensCarrinho(indice)">Remover</button>
            </div>
        </li>
        <li>Total: R$ {{state.valorTotalProduto()}}</li>
        <li class="finalizar"> <button @click.prevent="finalizarCompra">Finalizar comprar</button> </li>
    </ul>
    <ul v-else>
        <li> Não há itens no carrinho</li>
    </ul>
</template>
<script>
import { reactive } from '@vue/reactivity'
import { removeItensCarrinho, setValorTotalProdutoCarrinho } from '../../../store'
import { converteValorInteiroMoeda } from '../../../services/utils/index'
import { requestPOST } from '../../../services/http/index'
import { getState } from '../../../store/index'

export default {
    props: ['produtos'],
    setup (props) {

        const state = reactive({
            valorTotalProduto: () => {
                let valor = null
                let valorFormatado = null
                props.produtos.map(item => {
                    valor = valor + item.valor
                })
                valorFormatado = converteValorInteiroMoeda(valor)
                setValorTotalProdutoCarrinho(valorFormatado)
                return valorFormatado
            }
        })
        const finalizarCompra = () => {
            requestPOST(`${getState.env.VUE_APP_URL_API_LOJA}/finalizarCompra`, getState.itensAdicionadosCarrinho)
                .then(response => {
                    console.log(response)
                })
                .catch(e => {
                    console.log(e.response)
                })
        }

        return {
            state,
            removeItensCarrinho,
            setValorTotalProdutoCarrinho,
            converteValorInteiroMoeda,
            finalizarCompra
        }
    }
}
</script>



<style scoped>

ul {
    background-color: #ffffff;
    position: absolute;
    width: 19em;
    padding: 20px;
    margin-top: 1em;
    padding-top: 1em;
    right: 5px;
    overflow-y: auto;
    box-shadow: #797979 -3px 6px 9px -1px;
    max-height: 60vh;
}

ul li {
    padding: 5px 0 5px 0;
    border-bottom: 1px solid #cccccc78;
    display: table;
    width: 100%;
}
.remover-item-carrinho {
    float: right;
}
.is-small {
    font-size: 11px;
    padding: 5px;
    float: right;
}

</style>